// DEFINE GLOBAL TABLE
rawset(_G, "Gamma", {});

// Freeslots & SOC definitions

freeslot(
	"S_INVISIBLE_FAKE",
	"SPR_FIVS",

	"MT_GAMMA_SHOT",

	"S_GAMMA_SHOT",
	"S_GAMMA_SHOT2",
	"S_GAMMA_SHOT3",
	"S_GAMMA_SHOT4",
	"S_GAMMA_SHOT5",
	"S_GAMMA_SHOT6",
	"S_GAMMA_SHOT7",
	"S_GAMMA_SHOT_DONE",

	"S_GAMMA_SHOTEXPLODE",
	"S_GAMMA_SHOTEXPLODE2",
	"S_GAMMA_SHOTEXPLODE3",
	"S_GAMMA_SHOTEXPLODE4",
	"S_GAMMA_SHOTEXPLODE5",
	"S_GAMMA_SHOTEXPLODE6",
	"S_GAMMA_SHOTEXPLODE7",
	"S_GAMMA_SHOTEXPLODE8",
	"S_GAMMA_SHOTEXPLODE9",
	"S_GAMMA_SHOTEXPLODE10",
	"S_GAMMA_SHOTEXPLODE11",

	"S_GAMMA_SHOTFIZZLE",
	"S_GAMMA_SHOTFIZZLE2",
	"S_GAMMA_SHOTFIZZLE3",
	"S_GAMMA_SHOTFIZZLE4",
	"S_GAMMA_SHOTFIZZLE5",
	"S_GAMMA_SHOTFIZZLE6",
	"S_GAMMA_SHOTFIZZLE7",

	"SPR_GSHT",

	"MT_GAMMA_SHOTBLAST",
	"S_GAMMA_SHOTBLAST",
	"S_GAMMA_SHOTBLAST2",
	"S_GAMMA_SHOTBLAST3",
	"S_GAMMA_SHOTBLAST4",
	"S_GAMMA_SHOTBLAST5",
	"S_GAMMA_SHOTBLAST6",
	"S_GAMMA_SHOTBLAST7",
	"SPR_GBLS",

	"MT_GAMMA_SHOTTRAIL",
	"S_GAMMA_SHOTTRAIL",
	"S_GAMMA_SHOTTRAIL2",
	"S_GAMMA_SHOTTRAIL3",
	"S_GAMMA_SHOTTRAIL4",
	"S_GAMMA_SHOTTRAIL5",
	"S_GAMMA_SHOTTRAIL6",
	"SPR_GTRL",

	"MT_GAMMA_LASER",
	"S_GAMMA_LASER",
	"SPR_AIML",

	"MT_GAMMA_TARGET",
	"S_GAMMA_TARGET_YELLOW",
	"S_GAMMA_TARGET_RED",
	"SPR_GTRG",

	"MT_GAMMA_JETOVERLAY",
	"S_GAMMA_JETOVERLAY",
	"SPR_GJTO",

	"MT_GAMMA_JETSMOKE",
	"S_GAMMA_JETSMOKE",
	"S_GAMMA_JETSMOKE2",
	"S_GAMMA_JETSMOKE3",
	"SPR_GJTS",

	"MT_GAMMA_LANDDUST_SPAWNER",
	"MT_GAMMA_LANDDUST",
	"S_GAMMA_LANDDUST",
	"S_GAMMA_LANDDUST2",
	"S_GAMMA_LANDDUST3",
	"S_GAMMA_LANDDUST4",
	"S_GAMMA_LANDDUST5",
	"S_GAMMA_LANDDUST6",
	"S_GAMMA_STEPDUST",
	"S_GAMMA_STEPDUST2",
	"S_GAMMA_STEPDUST3",
	"SPR_GLND",

	"MT_GAMMA_BLASTEREXPLOSION_CENTER",
	"MT_GAMMA_BLASTEREXPLOSION",
	"S_GAMMA_BLASTEREXPLOSION",
	"SPR_GBEX",

	"MT_GAMMA_COOPJUMPGLOW",
	"S_GAMMA_COOPJUMPGLOW",
	"S_GAMMA_COOPJUMPGLOW2",
	"S_GAMMA_COOPJUMPGLOW3",
	"S_GAMMA_COOPJUMPGLOW4",
	"S_GAMMA_COOPJUMPGLOW5",
	"S_GAMMA_COOPJUMPGLOW6",
	"S_GAMMA_COOPJUMPGLOW7",
	"S_GAMMA_COOPJUMPGLOW8",
	"S_GAMMA_COOPJUMPGLOW9",
	"S_GAMMA_COOPJUMPGLOW10",
	"S_GAMMA_COOPJUMPGLOW11",
	"S_GAMMA_COOPJUMPGLOW12",
	"S_GAMMA_COOPJUMPGLOW13",
	"S_GAMMA_COOPJUMPGLOW14",
	"S_GAMMA_COOPJUMPGLOW15",
	"S_GAMMA_COOPJUMPGLOW16",
	"SPR_GJGW",

	"MT_GAMMA_ANIMATIONMASTER",
	"MT_GAMMA_PART",
	"S_GAMMA_PART",
	"S_GAMMA_PART_OVERLAY",

	"SPR2_PRTA",
	"SPR2_PRTB",
	"SPR2_PRTC",
	"SPR2_PRTD",
	"SPR2_PRTE",
	"SPR2_PRTF",
	"SPR2_PRTG",
	"SPR2_PRTH",
	"SPR2_PRTI",
	"SPR2_PRTJ",
	"SPR2_PRTK",
	"SPR2_PRTL",
	"SPR2_PRTM",
	"SPR2_PRTN",
	"SPR2_PRTO",
	"SPR2_PRTP",
	"SPR2_PRTQ",

	"SPR2_PBMA",
	"SPR2_PBMH",
	"SPR2_PBMN",
	"SPR2_PBMJ",

	"MT_GAMMA_FLICKY",
	"S_GAMMA_FLICKY_OUT",
	"S_GAMMA_FLICKY_FLAP1",
	"S_GAMMA_FLICKY_FLAP2",
	"S_GAMMA_FLICKY_FLAP3",
	"S_GAMMA_FLICKY_STAND",
	"S_GAMMA_FLICKY_HURT",
	"SPR_GMFL",

	"MT_GAMMA_FLICKY_CENTER",
	"S_GAMMA_FLICKY_CENTER",

	"SPR2_DRKA",
	"SPR2_DRKB",
	"SPR2_DRKC",
	"S_PLAY_GAMMA_DRINK_START",
	"S_PLAY_GAMMA_DRINK_LOOP",
	"S_PLAY_GAMMA_DRINK_END",

	"sfx_gmshot",
	"sfx_gmshex",
	"sfx_gmshfz",
	"sfx_gmshre",
	"sfx_gmkill",
	"sfx_gmhurt",
	"sfx_gmstep",
	"sfx_gmmoch",
	"sfx_gmhovr",
	"sfx_gmland",
	"sfx_gmlasr",
	"sfx_gmtarg",
	"sfx_gmdrvs",
	"sfx_gmdrvl",
	"sfx_gmdrvi",
	"sfx_gmtick",
	"sfx_gmhry1",
	"sfx_gmhry2",
	"sfx_gmsksw",
	"sfx_gmcano",
	"sfx_gmslrp",
	"sfx_snaphp",

	-- Hidden skincolors, for targets turning blue when expiring
	"SKINCOLOR_GAMMAEXPIRE00",
	"SKINCOLOR_GAMMAEXPIRE01",
	"SKINCOLOR_GAMMAEXPIRE02",
	"SKINCOLOR_GAMMAEXPIRE03",
	"SKINCOLOR_GAMMAEXPIRE04",
	"SKINCOLOR_GAMMAEXPIRE05",
	"SKINCOLOR_GAMMAEXPIRE06",
	"SKINCOLOR_GAMMAEXPIRE07",
	"SKINCOLOR_GAMMAEXPIRE08",
	"SKINCOLOR_GAMMAEXPIRE09",
	"SKINCOLOR_GAMMAEXPIRE10",
	"SKINCOLOR_GAMMAEXPIRE11",
	"SKINCOLOR_GAMMAEXPIRE12",
	"SKINCOLOR_GAMMAEXPIRE13",
	"SKINCOLOR_GAMMAEXPIRE14",
	"SKINCOLOR_GAMMAEXPIRE15",
	"SKINCOLOR_GAMMAEXPIRE16",

	-- Laser colors
	"SKINCOLOR_GAMMALASER",
	"SKINCOLOR_GAMMALASERSUPER",

	-- Score bonus colors
	"SKINCOLOR_GAMMABONUS1",
	"SKINCOLOR_GAMMABONUS2",
	"SKINCOLOR_GAMMABONUS3",
	"SKINCOLOR_GAMMABONUS4",
	"SKINCOLOR_GAMMABONUS5",
	"SKINCOLOR_GAMMABONUS6",
	"SKINCOLOR_GAMMABONUS7",
	"SKINCOLOR_GAMMABONUS8",
	"SKINCOLOR_GAMMABONUS9",
	"SKINCOLOR_GAMMABONUS10",
	"SKINCOLOR_GAMMABONUS11"
);

spr2defaults[SPR2_PRTO] = SPR2_PRTE; // Default big gun to small gun

states[S_PLAY_GAMMA_DRINK_START] = {SPR_PLAY, SPR2_DRKA, 120, nil, 0, 0, S_PLAY_GAMMA_DRINK_LOOP};
states[S_PLAY_GAMMA_DRINK_LOOP] = {SPR_PLAY, SPR2_DRKB, 40, function(mo, v1, v2)
	S_StartSound(mo, sfx_gmslrp);
end, 0, 0, S_PLAY_GAMMA_DRINK_LOOP};
states[S_PLAY_GAMMA_DRINK_END] = {SPR_PLAY, SPR2_DRKC, 60, nil, 0, 0, S_PLAY_STND};

states[S_INVISIBLE_FAKE] = {SPR_FIVS, A, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_SHOT] = {
	spawnstate = S_GAMMA_SHOT,
	deathstate = S_GAMMA_SHOTFIZZLE,
	xdeathstate = S_GAMMA_SHOTEXPLODE,
	spawnhealth = 1000,
	radius = 18*FRACUNIT,
	height = 18*FRACUNIT,
	speed = 64*FRACUNIT,
	reactiontime = 3*TICRATE,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

states[S_GAMMA_SHOT] = {SPR_GSHT, FF_FULLBRIGHT|A, 1, nil, 0, 0, S_GAMMA_SHOT2}
states[S_GAMMA_SHOT2] = {SPR_GSHT, FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_SHOT3}
states[S_GAMMA_SHOT3] = {SPR_GSHT, FF_FULLBRIGHT|C, 1, nil, 0, 0, S_GAMMA_SHOT4}
states[S_GAMMA_SHOT4] = {SPR_GSHT, FF_FULLBRIGHT|D, 1, nil, 0, 0, S_GAMMA_SHOT5}
states[S_GAMMA_SHOT5] = {SPR_GSHT, FF_FULLBRIGHT|E, 1, nil, 0, 0, S_GAMMA_SHOT6}
states[S_GAMMA_SHOT6] = {SPR_GSHT, FF_FULLBRIGHT|F, 1, nil, 0, 0, S_GAMMA_SHOT7}
states[S_GAMMA_SHOT7] = {SPR_GSHT, FF_FULLBRIGHT|G, 1, nil, 0, 0, S_GAMMA_SHOT}

// Give time for sounds to finish playing
states[S_GAMMA_SHOT_DONE] = {SPR_NULL, A, 3*TICRATE, nil, 0, 0, S_NULL}

states[S_GAMMA_SHOTEXPLODE] = {SPR_GSHT, FF_FULLBRIGHT|H, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE2}
states[S_GAMMA_SHOTEXPLODE2] = {SPR_GSHT, FF_FULLBRIGHT|I, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE3}
states[S_GAMMA_SHOTEXPLODE3] = {SPR_GSHT, FF_FULLBRIGHT|H, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE4}
states[S_GAMMA_SHOTEXPLODE4] = {SPR_GSHT, FF_FULLBRIGHT|J, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE5}
states[S_GAMMA_SHOTEXPLODE5] = {SPR_GSHT, FF_FULLBRIGHT|H, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE6}
states[S_GAMMA_SHOTEXPLODE6] = {SPR_GSHT, FF_FULLBRIGHT|K, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE7}
states[S_GAMMA_SHOTEXPLODE7] = {SPR_GSHT, FF_FULLBRIGHT|L, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE8}
states[S_GAMMA_SHOTEXPLODE8] = {SPR_GSHT, FF_FULLBRIGHT|M, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE9}
states[S_GAMMA_SHOTEXPLODE9] = {SPR_GSHT, FF_FULLBRIGHT|N, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE10}
states[S_GAMMA_SHOTEXPLODE10] = {SPR_GSHT, FF_FULLBRIGHT|O, 1, nil, 0, 0, S_GAMMA_SHOTEXPLODE11}
states[S_GAMMA_SHOTEXPLODE11] = {SPR_GSHT, FF_FULLBRIGHT|P, 1, nil, 0, 0, S_GAMMA_SHOT_DONE}

states[S_GAMMA_SHOTFIZZLE] = {SPR_GSHT, FF_FULLBRIGHT|Q, 1, nil, 0, 0, S_GAMMA_SHOTFIZZLE2}
states[S_GAMMA_SHOTFIZZLE2] = {SPR_GSHT, FF_FULLBRIGHT|R, 1, nil, 0, 0, S_GAMMA_SHOTFIZZLE3}
states[S_GAMMA_SHOTFIZZLE3] = {SPR_GSHT, FF_FULLBRIGHT|S, 1, nil, 0, 0, S_GAMMA_SHOTFIZZLE4}
states[S_GAMMA_SHOTFIZZLE4] = {SPR_GSHT, FF_FULLBRIGHT|T, 1, nil, 0, 0, S_GAMMA_SHOTFIZZLE5}
states[S_GAMMA_SHOTFIZZLE5] = {SPR_GSHT, FF_FULLBRIGHT|U, 1, nil, 0, 0, S_GAMMA_SHOTFIZZLE6}
states[S_GAMMA_SHOTFIZZLE6] = {SPR_GSHT, FF_FULLBRIGHT|V, 1, nil, 0, 0, S_GAMMA_SHOTFIZZLE7}
states[S_GAMMA_SHOTFIZZLE7] = {SPR_GSHT, FF_FULLBRIGHT|W, 1, nil, 0, 0, S_GAMMA_SHOT_DONE}

mobjinfo[MT_GAMMA_SHOTBLAST] = {
	spawnstate = S_GAMMA_SHOTBLAST,
	spawnhealth = 1000,
	radius = 18*FRACUNIT,
	height = 18*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

states[S_GAMMA_SHOTBLAST] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|A, 2, nil, 0, 0, S_GAMMA_SHOTBLAST2}
states[S_GAMMA_SHOTBLAST2] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_SHOTBLAST3}
states[S_GAMMA_SHOTBLAST3] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|C, 1, nil, 0, 0, S_GAMMA_SHOTBLAST4}
states[S_GAMMA_SHOTBLAST4] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|D, 1, nil, 0, 0, S_GAMMA_SHOTBLAST5}
states[S_GAMMA_SHOTBLAST5] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|E, 1, nil, 0, 0, S_GAMMA_SHOTBLAST6}
states[S_GAMMA_SHOTBLAST6] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|F, 1, nil, 0, 0, S_GAMMA_SHOTBLAST7}
states[S_GAMMA_SHOTBLAST7] = {SPR_GBLS, FF_PAPERSPRITE|FF_FULLBRIGHT|G, 1, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_SHOTTRAIL] = {
	spawnstate = S_GAMMA_SHOTTRAIL,
	spawnhealth = 1000,
	radius = 18*FRACUNIT,
	height = 18*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

states[S_GAMMA_SHOTTRAIL] = {SPR_GTRL, FF_PAPERSPRITE|FF_FULLBRIGHT|A, 2, nil, 0, 0, S_GAMMA_SHOTTRAIL2}
states[S_GAMMA_SHOTTRAIL2] = {SPR_GTRL, FF_PAPERSPRITE|FF_FULLBRIGHT|B, 7, nil, 0, 0, S_GAMMA_SHOTTRAIL3}
states[S_GAMMA_SHOTTRAIL3] = {SPR_GTRL, FF_PAPERSPRITE|FF_FULLBRIGHT|C, 2, nil, 0, 0, S_GAMMA_SHOTTRAIL4}
states[S_GAMMA_SHOTTRAIL4] = {SPR_GTRL, FF_PAPERSPRITE|FF_FULLBRIGHT|D, 2, nil, 0, 0, S_GAMMA_SHOTTRAIL5}
states[S_GAMMA_SHOTTRAIL5] = {SPR_GTRL, FF_PAPERSPRITE|FF_FULLBRIGHT|E, 2, nil, 0, 0, S_GAMMA_SHOTTRAIL6}
states[S_GAMMA_SHOTTRAIL6] = {SPR_GTRL, FF_PAPERSPRITE|FF_FULLBRIGHT|F, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_LASER] = {
	spawnstate = S_GAMMA_LASER,
	spawnhealth = 1000,
	radius = 15*FRACUNIT,
	height = FRACUNIT,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

states[S_GAMMA_LASER] = {SPR_AIML, FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT|A, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_TARGET] = {
	spawnstate = S_GAMMA_TARGET_YELLOW,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 5,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

states[S_GAMMA_TARGET_YELLOW] = {SPR_GTRG, FF_ANIMATE|FF_FULLBRIGHT|FF_PAPERSPRITE|A, -1, nil, 5, 2, S_NULL}
states[S_GAMMA_TARGET_RED] = {SPR_GTRG, FF_ANIMATE|FF_FULLBRIGHT|FF_PAPERSPRITE|G, -1, nil, 5, 2, S_NULL}

mobjinfo[MT_GAMMA_JETOVERLAY] = {
	spawnstate = S_GAMMA_JETOVERLAY,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

states[S_GAMMA_JETOVERLAY] = {SPR_GJTO, FF_ANIMATE|FF_FULLBRIGHT|A, -1, nil, 3, 1, S_NULL}

mobjinfo[MT_GAMMA_JETSMOKE] = {
	spawnstate = S_GAMMA_JETSMOKE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY
}

states[S_GAMMA_JETSMOKE] = {SPR_GJTS, FF_TRANS30|FF_FULLBRIGHT|A, 5, nil, 0, 0, S_GAMMA_JETSMOKE2}
states[S_GAMMA_JETSMOKE2] = {SPR_GJTS, FF_TRANS50|FF_FULLBRIGHT|B, 4, nil, 0, 0, S_GAMMA_JETSMOKE3}
states[S_GAMMA_JETSMOKE3] = {SPR_GJTS, FF_TRANS70|FF_FULLBRIGHT|C, 3, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_LANDDUST_SPAWNER] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY
}

mobjinfo[MT_GAMMA_LANDDUST] = {
	spawnstate = S_GAMMA_LANDDUST,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY
}

states[S_GAMMA_LANDDUST] = {SPR_GLND, FF_TRANS50|A, 2, nil, 0, 0, S_GAMMA_LANDDUST2}
states[S_GAMMA_LANDDUST2] = {SPR_GLND, FF_TRANS70|B, 1, nil, 0, 0, S_GAMMA_LANDDUST3}
states[S_GAMMA_LANDDUST3] = {SPR_GLND, FF_TRANS50|C, 1, nil, 0, 0, S_GAMMA_LANDDUST4}
states[S_GAMMA_LANDDUST4] = {SPR_GLND, FF_TRANS70|D, 1, nil, 0, 0, S_GAMMA_LANDDUST5}
states[S_GAMMA_LANDDUST5] = {SPR_GLND, FF_TRANS50|E, 1, nil, 0, 0, S_GAMMA_LANDDUST6}
states[S_GAMMA_LANDDUST6] = {SPR_GLND, FF_TRANS70|F, 1, nil, 0, 0, S_NULL}

states[S_GAMMA_STEPDUST] = {SPR_GLND, E, 2, nil, 0, 0, S_GAMMA_STEPDUST2}
states[S_GAMMA_STEPDUST2] = {SPR_GLND, FF_TRANS30|D, 1, nil, 0, 0, S_GAMMA_STEPDUST3}
states[S_GAMMA_STEPDUST3] = {SPR_GLND, FF_TRANS60|C, 1, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_BLASTEREXPLOSION_CENTER] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
}

mobjinfo[MT_GAMMA_BLASTEREXPLOSION] = {
	spawnstate = S_GAMMA_BLASTEREXPLOSION,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

states[S_GAMMA_BLASTEREXPLOSION] = {SPR_GBEX, FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT|A, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_COOPJUMPGLOW] = {
	spawnstate = S_GAMMA_COOPJUMPGLOW,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOCLIPTHING|MF_SCENERY
}

states[S_GAMMA_COOPJUMPGLOW] = {SPR_GJGW, FF_FULLBRIGHT|A, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW2}
states[S_GAMMA_COOPJUMPGLOW2] = {SPR_GJGW, FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW3}
states[S_GAMMA_COOPJUMPGLOW3] = {SPR_GJGW, FF_FULLBRIGHT|C, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW4}
states[S_GAMMA_COOPJUMPGLOW4] = {SPR_GJGW, FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW5}
states[S_GAMMA_COOPJUMPGLOW5] = {SPR_GJGW, FF_VERTICALFLIP|FF_FULLBRIGHT|A, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW6}
states[S_GAMMA_COOPJUMPGLOW6] = {SPR_GJGW, FF_VERTICALFLIP|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW7}
states[S_GAMMA_COOPJUMPGLOW7] = {SPR_GJGW, FF_VERTICALFLIP|FF_FULLBRIGHT|C, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW8}
states[S_GAMMA_COOPJUMPGLOW8] = {SPR_GJGW, FF_VERTICALFLIP|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW9}
states[S_GAMMA_COOPJUMPGLOW9] = {SPR_GJGW, FF_VERTICALFLIP|FF_HORIZONTALFLIP|FF_FULLBRIGHT|A, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW10}
states[S_GAMMA_COOPJUMPGLOW10] = {SPR_GJGW, FF_VERTICALFLIP|FF_HORIZONTALFLIP|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW11}
states[S_GAMMA_COOPJUMPGLOW11] = {SPR_GJGW, FF_VERTICALFLIP|FF_HORIZONTALFLIP|FF_FULLBRIGHT|C, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW12}
states[S_GAMMA_COOPJUMPGLOW12] = {SPR_GJGW, FF_VERTICALFLIP|FF_HORIZONTALFLIP|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW13}
states[S_GAMMA_COOPJUMPGLOW13] = {SPR_GJGW, FF_HORIZONTALFLIP|FF_FULLBRIGHT|A, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW14}
states[S_GAMMA_COOPJUMPGLOW14] = {SPR_GJGW, FF_HORIZONTALFLIP|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW15}
states[S_GAMMA_COOPJUMPGLOW15] = {SPR_GJGW, FF_HORIZONTALFLIP|FF_FULLBRIGHT|C, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW16}
states[S_GAMMA_COOPJUMPGLOW16] = {SPR_GJGW, FF_HORIZONTALFLIP|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_GAMMA_COOPJUMPGLOW}

mobjinfo[MT_GAMMA_ANIMATIONMASTER] = {
	spawnstate = S_INVISIBLE_FAKE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 96*FRACUNIT,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_GAMMA_PART] = {
	spawnstate = S_INVISIBLE_FAKE, -- S_GAMMA_PART
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

states[S_GAMMA_PART] = {SPR2_PRTA, 0, -1, nil, 0, 0, S_NULL}
states[S_GAMMA_PART_OVERLAY] = {SPR2_PRTA, 0, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_GAMMA_FLICKY] = {
	spawnstate = S_GAMMA_FLICKY_OUT,
	seestate = S_GAMMA_FLICKY_STAND,
	raisestate = S_FLICKY_BUBBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_NOCLIPTHING
}

states[S_GAMMA_FLICKY_OUT] = {SPR_GMFL, A, 2, A_FlickyCheck, S_GAMMA_FLICKY_FLAP1, S_GAMMA_FLICKY_FLAP1, S_GAMMA_FLICKY_OUT}
states[S_GAMMA_FLICKY_FLAP1] = {SPR_GMFL, B, 3, A_FlickyFly, 4*FRACUNIT, 16*FRACUNIT, S_GAMMA_FLICKY_FLAP2}
states[S_GAMMA_FLICKY_FLAP2] = {SPR_GMFL, C, 3, A_FlickyFly, 4*FRACUNIT, 16*FRACUNIT, S_GAMMA_FLICKY_FLAP3}
states[S_GAMMA_FLICKY_FLAP3] = {SPR_GMFL, D, 3, A_FlickyFly, 4*FRACUNIT, 16*FRACUNIT, S_GAMMA_FLICKY_FLAP1}
states[S_GAMMA_FLICKY_STAND] = {SPR_GMFL, FF_ANIMATE|B, -1, nil, 2, 3, S_NULL}
states[S_GAMMA_FLICKY_HURT] = {SPR_GMFL, E, -1, nil, 1, 50*FRACUNIT, S_NULL}

mobjinfo[MT_GAMMA_FLICKY_CENTER] = {
	spawnstate = S_GAMMA_FLICKY_CENTER,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_NOSECTOR|MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_RUNSPAWNFUNC
}

states[S_GAMMA_FLICKY_CENTER] = {SPR_NULL, A, -1, A_FlickyCenter, MT_GAMMA_FLICKY, 384*FRACUNIT, S_NULL} // | (1 << 20)

sfxinfo[sfx_gmshot].caption = "Shot";
sfxinfo[sfx_gmshex].caption = "Shot explosion";
sfxinfo[sfx_gmshfz].caption = "Shot fizzled";
sfxinfo[sfx_gmshre].caption = "Shot reflected";
sfxinfo[sfx_gmkill].caption = "Shot explosion"; // "Badnik busted"
sfxinfo[sfx_gmhurt].caption = "Ring loss";
sfxinfo[sfx_gmstep].caption = "Footstep";
sfxinfo[sfx_gmmoch].caption = "\"Mode change.\"";
sfxinfo[sfx_gmhovr].caption = "Jet booster";
sfxinfo[sfx_gmland].caption = "Stomp";
sfxinfo[sfx_gmlasr].caption = "Beeeeep";
sfxinfo[sfx_gmtarg].caption = "Target locked";
sfxinfo[sfx_gmdrvs].caption = "Driving";
sfxinfo[sfx_gmdrvl].caption = "Driving";
sfxinfo[sfx_gmdrvi].caption = "Hit wall";
sfxinfo[sfx_gmtick].caption = "Time added";
sfxinfo[sfx_gmhry1].caption = "\"Come on!\"";
sfxinfo[sfx_gmhry2].caption = "\"Hurry up!\"";
sfxinfo[sfx_gmsksw].caption = "\"Preparation complete.\"";
sfxinfo[sfx_gmcano].caption = "Soda can opening";
sfxinfo[sfx_gmslrp].caption = "Obnoxious robotic slurping";
sfxinfo[sfx_snaphp].caption = "Soda finished";

skincolors[SKINCOLOR_GAMMAEXPIRE00] = {
	name = "Gamma Expire 0",
	ramp = {73,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE01] = {
	name = "Gamma Expire 1",
	ramp = {64,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE02] = {
	name = "Gamma Expire 2",
	ramp = {52,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE03] = {
	name = "Gamma Expire 3",
	ramp = {54,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE04] = {
	name = "Gamma Expire 4",
	ramp = {55,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE05] = {
	name = "Gamma Expire 5",
	ramp = {35,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE06] = {
	name = "Gamma Expire 6",
	ramp = {34,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE07] = {
	name = "Gamma Expire 7",
	ramp = {33,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE08] = {
	name = "Gamma Expire 8",
	ramp = {202,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE09] = {
	name = "Gamma Expire 9",
	ramp = {180,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE10] = {
	name = "Gamma Expire 10",
	ramp = {181,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE11] = {
	name = "Gamma Expire 11",
	ramp = {182,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE12] = {
	name = "Gamma Expire 12",
	ramp = {164,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE13] = {
	name = "Gamma Expire 13",
	ramp = {165,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE14] = {
	name = "Gamma Expire 14",
	ramp = {166,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE15] = {
	name = "Gamma Expire 15",
	ramp = {153,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMAEXPIRE16] = {
	name = "Gamma Expire 16",
	ramp = {152,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMALASER] = {
	name = "Gamma Laser",
	ramp = {0,81,73,64,51,53,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMALASERSUPER] = {
	name = "Gamma Laser Super",
	ramp = {0,128,131,133,147,148,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS1] = {
	name = "Gamma Bonus Good",
	ramp = {131,135,137,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS2] = {
	name = "Gamma Bonus Nice",
	ramp = {120,123,126,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS3] = {
	name = "Gamma Bonus Great",
	ramp = {255,141,143,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS4] = {
	name = "Gamma Bonus Jammin",
	ramp = {88,189,191,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS5] = {
	name = "Gamma Bonus Cool",
	ramp = {72,65,68,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS6] = {
	name = "Gamma Bonus Radical",
	ramp = {64,53,59,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS7] = {
	name = "Gamma Bonus Tight",
	ramp = {51,56,60,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS8] = {
	name = "Gamma Bonus Awesome",
	ramp = {54,37,41,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS9] = {
	name = "Gamma Bonus Extreme",
	ramp = {201,182,185,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS10] = {
	name = "Gamma Bonus Perfect-Purple",
	ramp = {162,165,167,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

skincolors[SKINCOLOR_GAMMABONUS11] = {
	name = "Gamma Bonus Perfect-Blue",
	ramp = {148,150,155,0,0,0,0,0,0,0,0,0,0,0,0,0},
	accessible = false
}

// Constants
Gamma.LASERCOUNT = 48;
Gamma.LASERRADIUS = 16*FRACUNIT;
Gamma.LASERDIAMETER = Gamma.LASERRADIUS * 2;
Gamma.LASERDIST = Gamma.LASERCOUNT * Gamma.LASERDIAMETER;

Gamma.CASHINTIME = 3*TICRATE/2;
Gamma.CASHININTERP = TICRATE/2;
Gamma.WAUGHMPTIME = TICRATE/7;
Gamma.OFFSETSPEED = 6;

Gamma.LEVELSTARTPAUSE = 3*TICRATE;

Gamma.WATERVAL = FixedSqrt(3*FRACUNIT);

Gamma.ComboExpireBlink = (2*TICRATE) / 3;
Gamma.ComboExpire = 3*TICRATE + Gamma.ComboExpireBlink;
Gamma.ComboExpireWarning = TICRATE + Gamma.ComboExpireBlink;

Gamma.LASERCONE = ANG20;

Gamma.NUMBEROFFSET = 8 * FRACUNIT;

Gamma.PROPELLER_DELAY = TICRATE;

// Global variables
Gamma.BombList = {}
Gamma.MapTimeLimit = nil;
Gamma.CoopTimeTotals = {}

// General functions
Gamma.TableContains = function(tb, element)
	if (type(tb) != "table")
		return false;
	end

	for _,v in pairs(tb) do
		if (v == element)
			return true;
		end
	end

	return false;
end

Gamma.RemoveFromTable = function(tb, element)
	if (type(tb) != "table")
		return;
	end

	for k,v in pairs(tb) do
		if (v == element)
			table.remove(tb, k);
			//return;
		end
	end
end

Gamma.RemoveBlankSpotsFromTable = function(tb)
	local newTb = {};

	if (type(tb) != "table")
		return newTb;
	end

	for _,v in pairs(tb) do
		table.insert(newTb, v);
	end

	return newTb;
end

Gamma.RoundedInt = function(fixed)
	return FixedInt(FixedRound(fixed));
end

Gamma.Log2 = function(x)
	local precision = FRACBITS - 1; // need to reduce to fit into INT32
	local b = 1 << (precision - 1);
	local y = 0;

	if (x == 0)
		return INT32_MIN;
	end

	while (x < 1 << precision)
		x = $1 << 1;
		y = $1 - (1 << precision);
	end

	while (x >= 2 << precision)
		x = $1 >> 1;
		y = $1 + (1 << precision);
	end

	local z = x;

	for i = 0,precision-1 do
		z = z * z >> precision;

		if (z >= 2 << precision)
			z = $1 >> 1;
			y = $1 + b;
		end

		b = $1 >> 1;
	end

	return (y << 1) - FRACUNIT; // and then fudge here to get back to actual result
end

Gamma.SetLinkDraw = function(mo, linkTo)
	if not (mo and mo.valid)
		return;
	end

	if (linkTo and linkTo.valid)
	and (mo != linkTo)
		mo.tracer = linkTo;
		mo.flags2 = $1 | MF2_LINKDRAW;
	else
		mo.tracer = nil;
		mo.flags2 = $1 & ~MF2_LINKDRAW;
	end
end

Gamma.CappedPitch = function(x)
	local ROTANGLES = 72;
	local ROTANGDIFF = (360*FRACUNIT) / ROTANGLES;

	// Limit pitch to rollangle's visual increments
	// Helps patch up a little bit of the holes.
	return FixedAngle(Gamma.RoundedInt(FixedDiv(AngleFixed(x), ROTANGDIFF)) * ROTANGDIFF);
end

Gamma.PlayerIsFriendly = function(player, comparePlayer)
	if (gametyperules & GTR_FRIENDLY)
		// Always true.
		return true;
	end

	if not ((player and player.valid)
	and (comparePlayer and comparePlayer.valid))
		// Invalid players.
		return false;
	end

	if (Gamma.BattleAdded() == true)
		// Use Battle's teams.
		return CBW_Battle.MyTeam(player, comparePlayer);
	end

	if (gametyperules & GTR_TAG)
		// Consider tagged players a different team from un-tagged players.
		return ((player.pflags & PF_TAGIT) == (comparePlayer.pflags & PF_TAGIT))
	end

	if (gametyperules & GTR_TEAMS)
		// Only if you're on the same team.
		return (player.ctfteam == comparePlayer.ctfteam);
	end

	// Always false.
	return false;
end

Gamma.IsDisplayPlayer = function(player)
	if not (player and player.valid)
		return false;
	end

	if (displayplayer and displayplayer.valid)
	and (player == displayplayer)
		return true;
	elseif (secondarydisplayplayer and secondarydisplayplayer.valid)
	and (player == secondarydisplayplayer)
		return true;
	end

	return false;
end

Gamma.IsCowboyMap = function(map)
	if (mapheaderinfo[map] == nil)
		return false;
	end

	if (mapheaderinfo[map].skynum >= 13
	and mapheaderinfo[map].skynum <= 16)
		// ACZ sky textures
		return true;
	end

	if (mapheaderinfo[map].musname == "ACZ1"
	or mapheaderinfo[map].musname == "ACZ2"
	or mapheaderinfo[map].musname == "VSFANG"
	or mapheaderinfo[map].musname == "SPEC5"
	or mapheaderinfo[map].musname == "MP_DES"
	or mapheaderinfo[map].musname == "MP_GLZ"
	or mapheaderinfo[map].musname == "MP_GL2")
		// ACZ or desert music
		return true;
	end

	local desertWords = {
		"arid",
		"canyon",
		"wasteland",
		"sand",
		"desert",
		"mirage",
		"saloon",
		"western",
		"cactus",
		"cacti",
		"oasis",
		"gulch",
		"badland",
		"pyramid",
		"cowboy",
		"dune",
		"tumbleweed",
		"wild west",
		"roast",
	};

	local stageName = string.lower(mapheaderinfo[map].lvlttl);
	for i = 1,#desertWords do
		if (string.find(stageName, desertWords[i]) != nil)
			-- Has a very distinctly desert word in its title
			return true;
		end
	end

	return false;
end

Gamma.CowboyHatColor = function(mobj)
	if (mobj and mobj.valid)
		if (mobj.player and mobj.player.valid)
			return skincolors[mobj.player.skincolor].invcolor;
		end

		return skincolors[mobj.color].invcolor;
	end

	return SKINCOLOR_GREEN;
end

Gamma.InDrinkState = function(mobj)
	if not (mobj and mobj.valid)
		return false;
	end

	return (mobj.state == S_PLAY_GAMMA_DRINK_START
		or mobj.state == S_PLAY_GAMMA_DRINK_LOOP
		or mobj.state == S_PLAY_GAMMA_DRINK_END);
end

Gamma.CanDrink = function(player)
	if (player.powers[pw_carry] == CR_MINECART)
		-- I would LIKE players to drink during this,
		-- but it's one of those circumstances where it overwrites your state every frame,
		-- which means drink gets stuck on the first frame.
		-- If you like to do hardcode: please never do that because it makes freeslotted SPR2s completely worthless :V
		return false;
	end

	if (Gamma.InDrinkState(player.mo) == true)
		-- We're already mid-drink :)
		return true;
	end

	return (player.panim == PA_IDLE);
end

local birdColorCache = {};

-- Predetermined bird colors
birdColorCache[SKINCOLOR_RED] = SKINCOLOR_ROSY;
birdColorCache[SKINCOLOR_JET] = SKINCOLOR_TAN;
birdColorCache[SKINCOLOR_BLACK] = SKINCOLOR_TAN;
birdColorCache[SKINCOLOR_BLUE] = SKINCOLOR_FLAME;
birdColorCache[SKINCOLOR_ORANGE] = SKINCOLOR_COBALT;
birdColorCache[SKINCOLOR_MAGENTA] = SKINCOLOR_SEAFOAM;

Gamma.BirdColor = function(mobj)
	local baseColor = SKINCOLOR_RED;
	if (mobj and mobj.valid)
		if (mobj.player and mobj.player.valid)
			baseColor = mobj.player.skincolor;
		else
			baseColor = mobj.color;
		end
	end

	if (birdColorCache[baseColor] != nil)
		return birdColorCache[baseColor];
	end

	local newColor = skincolors[ baseColor ].invcolor;
	local shift = 7;
	while (shift > 0)
		if (baseColor & 1)
			newColor = M_GetColorBefore($1);
		else
			newColor = M_GetColorAfter($1);
		end
		shift = $1 - 1;
	end

	birdColorCache[baseColor] = newColor;
	return newColor;
end
