Gamma.DriveDust = function(player, id, startup)
	local legMobj = Gamma.GetPartMobj(player, id);
	if not (legMobj and legMobj.valid)
		return;
	end

	local dust = P_SpawnMobjFromMobj(legMobj, 0, 0, 0, MT_SPINDUST);
	dust.angle = legMobj.angle;
	P_SetObjectMomZ(dust, P_RandomRange(1, 4) << FRACBITS, false);

	if (startup == true)
		if (player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER))
			dust.state = S_SPINDUST_BUBBLE1;
			dust.destscale = $1 * 2;
		end

		dust.destscale = $1 * 2;
	else
		if (player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER))
			dust.state = S_SPINDUST_BUBBLE2;
			dust.destscale = $1 * 2;
		else
			dust.state = S_SPINDUST2;
		end

		dust.tics = 3;
		dust.momz = $1 / 2;
	end
end

Gamma.LandDust = function(mo)
	local a = mo.angle + ANGLE_45;

	for i = 0,3 do
		local spawner = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_GAMMA_LANDDUST_SPAWNER);
		spawner.angle = a;

		local speed = 16;
		spawner.momx = FixedMul(speed * cos(spawner.angle), spawner.scale);
		spawner.momy = FixedMul(speed * sin(spawner.angle), spawner.scale);

		spawner.tics = 4;

		a = $1 + ANGLE_90;
	end
end

Gamma.LandDustSpawner = function(mo)
	local dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_GAMMA_LANDDUST);
end

Gamma.StepDust = function(player, id)
	// Don't like this after all.
	return;

	/*
	local footMobj = Gamma.GetPartMobj(player, id);
	if not (footMobj and footMobj.valid)
		return;
	end

	local dust = P_SpawnMobjFromMobj(footMobj, 0, 0, 0, MT_GAMMA_LANDDUST);
	dust.state = S_GAMMA_STEPDUST;
	P_SetScale(dust, dust.scale / 2);

	local a = footMobj.angle + ANGLE_180;
	local speed = 6;
	local mx = FixedMul(speed * cos(a), dust.scale);
	local my = FixedMul(speed * sin(a), dust.scale);

	P_TryMove(dust, dust.x + (mx * 4), dust.y + (my * 4), false);
	dust.momx = mx;
	dust.momy = my;
	*/
end
