Gamma.AnimationDefs = {
	[SPR2_STND] = {
		speed = 4,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 7, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 7, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
		},
	},
	[SPR2_WAIT] = {
		speed = 2,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_67h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 4, ang = -ANGLE_45},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 4, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 3, ang = ANGLE_67h},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 6, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 3, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 2, ang = ANGLE_22h},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 6, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 3, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 2, ang = -ANGLE_22h},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = -ANGLE_22h},
			},
		},
	},
	[SPR2_WALK] = {
		speed = 4,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 3, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 2, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[2] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[3] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 2, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[4] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 1, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[5] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 2, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[6] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[7] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 2, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[8] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 5, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 1, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
		},
	},
	[SPR2_ROLL] = {
		speed = 1,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 11, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 1, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 1, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
		},
	},
	[SPR2_SPNG] = {
		speed = 7,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 10, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 6, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 6, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 5, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 4, ang = ANGLE_11hh},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 5, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 4, ang = -ANGLE_11hh},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 4, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 4, ang = -ANGLE_11hh},
			},
		},
	},
	[SPR2_FALL] = {
		speed = 2,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 12, ang = -ANGLE_45},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 10, ang = -ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 6, ang = -ANGLE_45},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 12, ang = ANGLE_45},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 10, ang = ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 6, ang = ANGLE_45},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 1, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 1, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 1, ang = 0},
			},
		},
	},
	[SPR2_FLT] = {
		speed = 2,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_67h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 4, ang = -ANGLE_45},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 4, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 3, ang = ANGLE_67h},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 6, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 2, ang = ANGLE_22h},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 6, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 2, ang = -ANGLE_22h},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 3, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 3, ang = -ANGLE_22h},
			},
		},
	},
	[SPR2_FLY] = {
		speed = 1,
		setInstantly = false,
		noSwivel = false,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 11, ang = -ANGLE_67h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_67h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 0, ang = ANGLE_90},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 0, ang = -ANGLE_90},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
		},
	},
	[SPR2_PAIN] = {
		speed = 1,
		setInstantly = false,
		noSwivel = true,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 7, ang = ANGLE_67h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = ANGLE_11hh},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 7, ang = -ANGLE_67h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 5, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 3, ang = -ANGLE_11hh},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 2, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 1, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 0, ang = ANGLE_22h},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 2, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 1, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 0, ang = -ANGLE_22h},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 0, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 0, ang = -ANGLE_22h},
			},
		},
	},
	[SPR2_RIDE] = {
		speed = 2,
		setInstantly = true,
		noSwivel = true,
		zOffset = -32,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 7, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 12, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 9, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 6, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 2, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 2, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 0, ang = 0},
			},
		},
	},
	[SPR2_DRKA] = {
		speed = 2,
		setInstantly = false,
		noSwivel = true,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 7, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[2] = {
				hold = 5,

				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 7, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[3] = {
				hold = 12,

				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 6, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 4, ang = ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 3, ang = ANGLE_90 - ANGLE_11hh},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[4] = {
				hold = 2,
				sfx = sfx_gmcano,

				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 6, ang = -ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 4, ang = ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 2, ang = ANGLE_90 - ANGLE_11hh},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 6, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[5] = {
				hold = 5,

				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 7, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[6] = {
				hold = -1,
				sfx = sfx_gmslrp,

				[Gamma.AnimPartIDs.HEAD] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 6, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 4, ang = -ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_90 - ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 5, ang = ANGLE_90},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 8, ang = ANGLE_90},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
		},
	},
	[SPR2_DRKB] = {
		speed = 2,
		setInstantly = true,
		noSwivel = true,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 6, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 4, ang = -ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_90 - ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 5, ang = ANGLE_90},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 8, ang = ANGLE_90},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
		},
	},
	[SPR2_DRKC] = {
		speed = 1,
		setInstantly = false,
		noSwivel = true,
		zOffset = 0,
		props = {
			[1] = {
				[Gamma.AnimPartIDs.HEAD] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 6, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 4, ang = -ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_90 - ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 5, ang = ANGLE_90},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 8, ang = ANGLE_90},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[2] = {
				hold = 8,

				[Gamma.AnimPartIDs.HEAD] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 6, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 4, ang = -ANGLE_45},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_90 - ANGLE_11hh},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 5, ang = ANGLE_90},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 8, ang = ANGLE_90},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[2] = {
				hold = 8,

				[Gamma.AnimPartIDs.HEAD] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.TORSO] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.WAIST] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 10, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 8, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 7, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = 0},
			},
			[3] = {
				hold = 8,
				sfx = sfx_snaphp,

				[Gamma.AnimPartIDs.HEAD] = {spr = 0, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.TORSO] = {spr = 0, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.WAIST] = {spr = 0, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = ANGLE_11hh},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = ANGLE_11hh},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 3, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 1, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 2, ang = -ANGLE_22h},
			},
			[4] = {
				hold = -1,

				[Gamma.AnimPartIDs.HEAD] = {spr = 2, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.TORSO] = {spr = 2, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.WAIST] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.PROPELLER] = {spr = 0, ang = 0},

				[Gamma.AnimPartIDs.UPPERARM_L] = {spr = 9, ang = -ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_L] = {spr = 5, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.LOWERARM_L] = {spr = 3, ang = ANGLE_22h},

				[Gamma.AnimPartIDs.UPPERARM_R] = {spr = 11, ang = ANGLE_22h},
				[Gamma.AnimPartIDs.MIDARM_R] = {spr = 9, ang = 0},
				[Gamma.AnimPartIDs.LOWERARM_R] = {spr = 4, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_L] = {spr = 5, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_L] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_L] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.UPPERLEG_R] = {spr = 7, ang = 0},
				[Gamma.AnimPartIDs.MIDLEG_R] = {spr = 4, ang = 0},
				[Gamma.AnimPartIDs.LOWERLEG_R] = {spr = 3, ang = 0},

				[Gamma.AnimPartIDs.FOOT_L] = {spr = 2, ang = 0},
				[Gamma.AnimPartIDs.FOOT_R] = {spr = 3, ang = -ANGLE_22h},
			},
		},
	},
}
